/*
	PROforma, PROgs FOnt & Raster MAnager

	CopyArea function, to copy a part of the bitmap
	generic version - suitable for all bitmap types
	has to be able to copy inside one byffer

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 28 September 1995
*/

#include "mem_h"

#include "gstate_h"

Error CursorSet(Bitmap, short x, short y);
Error PixelReadNextX(Bitmap, int *colour);
Error PixelReadPrevX(Bitmap, int *colour);
Error PixelSetNextX(Bitmap, int colour);
Error PixelSetPrevX(Bitmap, int colour);

Error CopyArea(Bitmap from, Bitmap to, short xsiz, short ysiz,
			   short fromx, short fromy, short tox, short toy)
{
	Error (*PixelRead)(Bitmap, int *colour);
	Error (*PixelSet)(Bitmap, int colour);
	short nextline=1;
	int colour, i,j;
	struct _Bitmap dummy;

	PixelRead=PixelReadNextX;
	PixelSet =PixelSetNextX;

	if (from==to)
	{
		/* make sure we can use two cursors */
		to=&dummy;
		MEMCopy(sizeof(struct _Bitmap),from,to);

		if (tox>fromx)
		{
			fromx+=xsiz;
			tox+=xsiz;
			PixelRead=PixelReadPrevX;
			PixelSet =PixelSetPrevX;
		}
		if (toy>fromy)
		{
			fromy+=ysiz;
			toy+=ysiz;
			nextline=-1;
		}
	}

	for (j=ysiz ; j ; j--)
	{
		CursorSet(from,fromx,fromy);
		CursorSet(	to,  tox,  toy);
		for (i=xsiz ; i ; i--)
		{
			PixelRead(from,&colour);
			PixelSet (	to, colour);
		}
		fromy+=nextline;
		toy  +=nextline;
	}
	return ERR_OK;
}
