/*
	PROforma, PROgs FOnt & Raster MAnager

	QVME screen driver - mode 4 only

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 28 September 1995
*/

#include "gstate_h"

static Error nimp() 	{ return ERR_NIMP; }
static Error nothing()	{ return ERR_OK; }

Error InitDriver();
Error Define(char *name, char *value);

Error InitInit(Gstate, char *device, PBbox *area);
Error BufferSize(Gstate, int xsiz, int ysiz, Size *size);
Error InitDone(Gstate);
Error CleanUp(Gstate);

Error InitPage(Gstate);
Error ShowPage(Gstate);
Error StopPage(Gstate);

Error SetCopies(Gstate, int count);
Error DisplayMode(Gstate, int mode);
Error WindowMove(Gstate, int dx, int dy);
Error BufferUpdate(Gstate);
Error BufferSave(Gstate);
Error BufferRestore(Gstate);

Error ColourAdjust(Gstate, ColourRGB *);
Error ColourNearest(Gstate, ColourRGB *, int *);
Error ColourDelta(Gstate, ColourRGB *, ColourRGB *);

Error GetFullPageBbox(Gstate, Bbox *box);
Error DefaultDevice(Gstate, char *device);

#define InitPage		(Error (*)(Gstate))nothing
#define StopPage		(Error (*)(Gstate))nothing
#define ColourAdjust	(Error (*)(Gstate,ColourRGB *))nothing
#define Define			(Error (*)(char *name, char *value))nimp
#define SetCopies		(Error (*)(Gstate, int count))nimp
#define GetFullPageBbox (Error (*)(Gstate, Bbox *box))nimp
#define DefaultDevice	(Error (*)(Gstate, char *device))nimp
#define Handle			nimp

DRIVdriver init={
	NULL, PF_SCREENDRIVER,
	"mode 4 screen driver", 	/* name */
	1,1,						/* xdpi, ydpi */
	{                           /* mode 4 bitmap */
		2, 1,					/* 2 planes, each 1 pixel deep */
		BITMAP_NO_BYTEGROUPING, /* no byte grouping */
		1,						/* altenative bytes in each plane */
	},

	InitDriver,
	Define,

	InitInit,
	BufferSize,
	InitDone,
	CleanUp,

	InitPage,
	ShowPage,
	StopPage,

	SetCopies,
	DisplayMode,
	WindowMove,

	BufferUpdate,
	BufferSave,
	BufferRestore,

	PF_COLOURSPACE_RGB,
	{
		ColourAdjust,
		ColourNearest,
		ColourDelta
	},

	GetFullPageBbox,
	DefaultDevice,

	Handle
};
