/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 29 September 1995
*/

#include "sms_h"
#include "job_h"
#include "time_h"

#include "PROforma_h"

#define BOX 100
#define XORG (595-4*BOX)/2
#define YORG (842-4*BOX)/2
Bbox bbox={short2pt(4*BOX), short2pt(4*BOX),short2pt(XORG),short2pt(YORG)};

ColourCMYK cyan0={ pt_hundred/4,0,0,0 };
ColourCMYK cyan1={ pt_hundred/3,0,0,0 };
ColourCMYK cyan2={ pt_hundred/2,0,0,0 };
ColourCMYK cyan3={ pt_hundred  ,0,0,0 };
ColourCMYK magenta0={ 0,pt_hundred/4,0,0 };
ColourCMYK magenta1={ 0,pt_hundred/3,0,0 };
ColourCMYK magenta2={ 0,pt_hundred/2,0,0 };
ColourCMYK magenta3={ 0,pt_hundred  ,0,0 };
ColourCMYK yellow0={ 0,0,pt_hundred/4,0 };
ColourCMYK yellow1={ 0,0,pt_hundred/3,0 };
ColourCMYK yellow2={ 0,0,pt_hundred/2,0 };
ColourCMYK yellow3={ 0,0,pt_hundred  ,0 };
ColourCMYK black0={ 0,0,0,pt_hundred/4 };
ColourCMYK black1={ 0,0,0,pt_hundred/3 };
ColourCMYK black2={ 0,0,0,pt_hundred/2 };
ColourCMYK black3={ 0,0,0,pt_hundred   };
 

void drawbox(Gstate gstate, short x, short y)
{
	PFPathFilled(gstate);
	PFMoveTo(gstate,short2pt(XORG+x*BOX),short2pt(YORG+y*BOX));
	PFLineR(gstate,short2pt(BOX),0);
	PFLineR(gstate,0,short2pt(BOX));
	PFLineR(gstate,-short2pt(BOX),0);
	PFPathClose(gstate);
	PFPathDraw(gstate);
}

Error init()
{
	Gstate gstate;
	Error err;
	short c,m,y,k;

	LinkPROforma();
	err=PFGstateInit((int)"Epson Stylus Colour 360dpi",NULL,&bbox,&gstate,NULL);
	if (err) return err;

	PFColourCMYK(gstate,&cyan0);
	drawbox(gstate,0,0);
	PFColourCMYK(gstate,&cyan1);
	drawbox(gstate,0,1);
	PFColourCMYK(gstate,&cyan2);
	drawbox(gstate,0,2);
	PFColourCMYK(gstate,&cyan3);
	drawbox(gstate,0,3);

	PFColourCMYK(gstate,&magenta0);
	drawbox(gstate,1,0);
	PFColourCMYK(gstate,&magenta1);
	drawbox(gstate,1,1);
	PFColourCMYK(gstate,&magenta2);
	drawbox(gstate,1,2);
	PFColourCMYK(gstate,&magenta3);
	drawbox(gstate,1,3);

	PFColourCMYK(gstate,&yellow0);
	drawbox(gstate,2,0);
	PFColourCMYK(gstate,&yellow1);
	drawbox(gstate,2,1);
	PFColourCMYK(gstate,&yellow2);
	drawbox(gstate,2,2);
	PFColourCMYK(gstate,&yellow3);
	drawbox(gstate,2,3);

	PFColourCMYK(gstate,&black0);
	drawbox(gstate,3,0);
	PFColourCMYK(gstate,&black1);
	drawbox(gstate,3,1);
	PFColourCMYK(gstate,&black2);
	drawbox(gstate,3,2);
	PFColourCMYK(gstate,&black3);
	drawbox(gstate,3,3);

	return PFPageShow(gstate);
}
