/*
	PROforma, PROGS Font & Raster Manager

	general header file for ESC/P printer drivers

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 24 January 1996, based on pcl_h
*/

#include "gstate_h"

typedef struct _DriverInfo {
	Channel channel;		/* the output channel for this driver */
	int pins;				/* number of pins to use 8 or 24 */
	int options;			/* extra options */
	int bit;				/* next bit for transform */
	int skip_lines; 		/* no of empty lines */
	int xskip, yskip;		/* skip values to end up at the topleft */
	char *buffer;
	} DriverInfo;

/* possible resolutions */

/* extra printer options */
#define SETA4		0x0001			/* set A4 page size */
#define HIGH		0x0002			/* high resolution printing */
#define NECP5		0x0004			/* nec P5 option for high resolution */
