/*
	PROforma, PROgs FOnt & Raster MAnager

	drawing routines for mode 4 bitmap driver
	cursor handling
	pixel setting
	pixel reading

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 2 October 1995
   */

#include "gstate_h"

Error CursorSet(Bitmap bitmap, short x, short y)
{
	bitmap->xcursor=x;
	bitmap->ycursor=y;
	bitmap->cursorpos=bitmap->base+y*bitmap->linc+x/8*2;
	bitmap->cursorbit=7-(x&7);
	bitmap->cursormask=0x0101<<bitmap->cursorbit;
	return ERR_OK;
}
Error CursorMove(Bitmap bitmap, short x, short y)
{
	return CursorSet(bitmap, bitmap->xcursor+x,bitmap->ycursor+y);
}
Error CursorGet(Bitmap bitmap, short *x, short *y)
{
	*x=bitmap->xcursor;
	*y=bitmap->ycursor;
	return ERR_OK;
}

#define READ	*colour=(((bitmap->cursorpos[0]>>bitmap->cursorbit)&1)<<1) + \
						 ((bitmap->cursorpos[1]>>bitmap->cursorbit)&1);
#define SET 	*((short *)bitmap->cursorpos)&=~bitmap->cursormask; \
				bitmap->cursorpos[0]|=((colour>>1)&1)<<bitmap->cursorbit; \
				bitmap->cursorpos[1]|=( colour	  &1)<<bitmap->cursorbit;
#define NEXTX	bitmap->xcursor++; bitmap->cursormask>>=1; \
				if ((--bitmap->cursorbit)<0) { \
					bitmap->cursormask=0x8080; \
					bitmap->cursorpos+=2; \
					bitmap->cursorbit=7; }
#define PREVX	bitmap->xcursor--; bitmap->cursormask<<=1; \
				if ((++bitmap->cursorbit)==8) { \
					bitmap->cursormask=0x0101; \
					bitmap->cursorpos-=2; \
					bitmap->cursorbit=0; }
#define NEXTY	bitmap->cursorpos+=bitmap->linc; bitmap->ycursor++;
#define PREVY	bitmap->cursorpos-=bitmap->linc; bitmap->ycursor--;

Error PixelRead(Bitmap bitmap, int *colour)
{
	READ;
	return ERR_OK;
}
Error PixelReadNextX(Bitmap bitmap, int *colour)
{
	READ;
	NEXTX;
	return ERR_OK;
}
Error PixelReadPrevX(Bitmap bitmap, int *colour)
{
	READ;
	PREVX;
	return ERR_OK;
}
Error PixelReadNextY(Bitmap bitmap, int *colour)
{
	READ;
	NEXTY;
	return ERR_OK;
}
Error PixelReadPrevY(Bitmap bitmap, int *colour)
{
	READ;
	PREVY;
	return ERR_OK;
}
Error PixelSet(Bitmap bitmap, int colour)
{
	SET;
	return ERR_OK;
}
Error PixelSetNextX(Bitmap bitmap, int colour)
{
	SET;
	NEXTX;
	return ERR_OK;
}
Error PixelSetPrevX(Bitmap bitmap, int colour)
{
	SET;
	PREVX;
	return ERR_OK;
}
Error PixelSetNextY(Bitmap bitmap, int colour)
{
	SET;
	NEXTY;
	return ERR_OK;
}
Error PixelSetPrevY(Bitmap bitmap, int colour)
{
	SET;
	PREVY;
	return ERR_OK;
}
