/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 29 September 1995
*/

#include "sms_h"
#include "job_h"
#include "time_h"

#include "PROforma_h"

Bbox bbox={short2pt(200), short2pt(100),0,0};
ColourRGB darkgreen={0,short2pt(30),0};

Error init()
{
	Gstate gstate;
	Error err;

	LinkPROforma();
	err=PFGstateInit(PF_DRIVER_SCREEN,NULL,&bbox,&gstate,NULL);
	if (err) return err;
	err=PFPageShow(gstate);
	if (err) return err;
	err=PFPageClear(gstate);
	if (err) return err;

	PFPathStroked(gstate);

	PFColourRGB(gstate,&darkgreen);
	PFLineWidth(gstate,short2pt(10));
	PFMoveTo(gstate,short2pt(20),short2pt(20));
	PFLineTo(gstate,short2pt(180),short2pt(80));
	PFPathDraw(gstate);

	PFColourGray(gstate,0);
	PFLineWidth(gstate,0);
	PFMoveTo(gstate,short2pt(20),short2pt(20));
	PFLineTo(gstate,short2pt(180),short2pt(80));
	PFPathDraw(gstate);

	err=PFPageShow(gstate);

	{
		Time start, curr;

		/* wait for approx 5sec. */
		TIMEGet(&start);
		do {
			JOBSuspend(MYSELF,1,NULL);
			TIMEGet(&curr);
		} while (start+5>curr);
	}
	return err;
}
