/*
	PROforma, PROGS Font & Raster Manager

	general header file for PCL printer drivers

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 04 October 1995
*/

#include "gstate_h"

typedef struct _DriverInfo {
	Channel channel;		/* the output channel for this driver */
	int type;				/* type of printer - for general pcl routines */
	int compression;		/* current compression method */
	int skip_lines; 		/* no of empty lines */
	int copies; 			/* no of copies we want */
	int xskip, yskip;		/* skip values to end up at the topleft */
	char *out_line;
	char *prev_line;
	char *alt_line;
	} DriverInfo;

/* Printer types */
#define LEVEL3		0				/* no compression */
#define LEVEL4		2				/* mode 2 compression is best possible */
#define LEVEL5		3				/* mode 2 and mode 3 compression */
#define COMPRESS	0x0ff
#define NORESET 	0x100			/* do not reset */
#define MINIMARGIN	0x200			/* use small margins - 4mm each side */
#define UNIT		0x400			/* support for "0x1bu#D" */
