/*
	PROforma, PROgs FOnt & Raster MAnager

	BITMdriver definition file for bitmaps with multiple planes, but each
	plane is only one bit deep. These routines basically call the mono driver
	routines for each of the planes.

	4 planes !!

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 4 November 1995
*/

#include "gstate_h"
#include "bitm_planes_h"

#define PLANECOUNT 4
#define PLANEDEPTH 1
BITMdriver planes4; 				/* forward declaration */

static Error nimp()    { return ERR_NIMP; }

PLANB(planes4,Black 	 ,Pixel 			 ,(bitmap,a,b)		  ,(Bitmap bitmap,short a,short b));
PLANB(planes4,Black 	 ,LineHorizontal	 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANB(planes4,Black 	 ,LineVertical		 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANB(planes4,Black 	 ,Block 			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,short a,short b,short c,short d));
PLANB(planes4,Black 	 ,TrapezoidHorizontal,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANB(planes4,Black 	 ,TrapezoidVertical  ,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANB(planes4,Black 	 ,HairLine			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,pt a,pt b,pt c,pt d));
PLANB(planes4,Black 	 ,DrawMask			 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,Mask *a,short b,short c));
PLANO(planes4,Black 	 ,ChangeOrigin);

PLANE(planes4,White 	 ,Pixel 			 ,(bitmap,a,b)		  ,(Bitmap bitmap,short a,short b));
PLANE(planes4,White 	 ,LineHorizontal	 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANE(planes4,White 	 ,LineVertical		 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANE(planes4,White 	 ,Block 			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,short a,short b,short c,short d));
PLANE(planes4,White 	 ,TrapezoidHorizontal,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANE(planes4,White 	 ,TrapezoidVertical  ,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANE(planes4,White 	 ,HairLine			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,pt a,pt b,pt c,pt d));
PLANE(planes4,White 	 ,DrawMask			 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,Mask *a,short b,short c));
PLANO(planes4,White 	 ,ChangeOrigin);

PLANE(planes4,FastPattern,Pixel 			 ,(bitmap,a,b)		  ,(Bitmap bitmap,short a,short b));
PLANE(planes4,FastPattern,LineHorizontal	 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANE(planes4,FastPattern,LineVertical		 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANE(planes4,FastPattern,Block 			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,short a,short b,short c,short d));
PLANE(planes4,FastPattern,TrapezoidHorizontal,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANE(planes4,FastPattern,TrapezoidVertical  ,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANE(planes4,FastPattern,HairLine			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,pt a,pt b,pt c,pt d));
PLANE(planes4,FastPattern,DrawMask			 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,Mask *a,short b,short c));
PLANO(planes4,FastPattern,ChangeOrigin);

PLANE(planes4,Pattern	 ,Pixel 			 ,(bitmap,a,b)		  ,(Bitmap bitmap,short a,short b));
PLANE(planes4,Pattern	 ,LineHorizontal	 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANE(planes4,Pattern	 ,LineVertical		 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,short a,short b,short c));
PLANE(planes4,Pattern	 ,Block 			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,short a,short b,short c,short d));
PLANE(planes4,Pattern	 ,TrapezoidHorizontal,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANE(planes4,Pattern	 ,TrapezoidVertical  ,(bitmap,a,b,c,d,e,f),(Bitmap bitmap,short a,short b,pt c,pt d,pt e,pt f));
PLANE(planes4,Pattern	 ,HairLine			 ,(bitmap,a,b,c,d)	  ,(Bitmap bitmap,pt a,pt b,pt c,pt d));
PLANE(planes4,Pattern	 ,DrawMask			 ,(bitmap,a,b,c)	  ,(Bitmap bitmap,Mask *a,short b,short c));
PLANO(planes4,Pattern	 ,ChangeOrigin);

/* general pixel handling commands */

static Error CursorSet(Bitmap bitmap, short x, short y)
{   return init.CursorSet(bitmap,x,y);  }
static Error CursorMove(Bitmap bitmap, short x, short y)
{   return init.CursorMove(bitmap,x,y); }
static Error CursorGet(Bitmap bitmap, short *x, short *y)
{   return init.CursorGet(bitmap,x,y);  }

PIXREAD(PixelRead	  ,PixelRead);
PIXREAD(PixelReadNextX,PixelRead);
PIXREAD(PixelReadPrevX,PixelRead);
PIXREAD(PixelReadNextY,PixelRead);
PIXREAD(PixelReadPrevY,PixelRead);
PIXSET(PixelSet 	,PixelSet);
PIXSET(PixelSetNextX,PixelSet);
PIXSET(PixelSetPrevX,PixelSet);
PIXSET(PixelSetNextY,PixelSet);
PIXSET(PixelSetPrevY,PixelSet);

static Error CopyArea(Bitmap from, Bitmap to, short xsiz, short ysiz,
			   short fromx, short fromy, short tox, short toy)
{
	int i; Error err;
	unsigned char *fbase=from->base;
	unsigned char *tbase=to->base;
	for (i=PLANECOUNT ; i ; i--)
	{
		err=init.CopyArea(from,to,xsiz,ysiz,fromx,fromy,tox,toy);
		from->base+=from->pinc;
		if (from!=to) to->base+=to->pinc;
	}
	from->base=fbase;
	to->base=tbase;
	return err;
}

static Error BufferSize(short xsiz, short ysiz, Size *size)
{
	Size siz;
	init.BufferSize(xsiz,ysiz,&siz);
	*size=siz*PLANECOUNT;
	return ERR_OK;
}

BITMdriver planes4={
	NULL, PF_BITMAPDRIVER,
	{
		4, 1,					/* 1 planes, each 1 pixel deep */
		BITMAP_NO_BYTEGROUPING, /* no byte grouping */
		BITMAP_NO_PLANES		/* altenative bytes in each plane */
	},

	/* drawing routines */
	{                               /* Black drawing routines */
		BlackPixel,
		BlackLineHorizontal,
		BlackLineVertical,
		BlackBlock,
		BlackTrapezoidHorizontal,
		BlackTrapezoidVertical,
		BlackHairLine,
		BlackDrawMask,
		BlackChangeOrigin
	},
	{                               /* White drawing routines */
		WhitePixel,
		WhiteLineHorizontal,
		WhiteLineVertical,
		WhiteBlock,
		WhiteTrapezoidHorizontal,
		WhiteTrapezoidVertical,
		WhiteHairLine,
		WhiteDrawMask,
		WhiteChangeOrigin
	},
	{                               /* FastPattern drawing routines */
		FastPatternPixel,
		FastPatternLineHorizontal,
		FastPatternLineVertical,
		FastPatternBlock,
		FastPatternTrapezoidHorizontal,
		FastPatternTrapezoidVertical,
		FastPatternHairLine,
		FastPatternDrawMask,
		FastPatternChangeOrigin
	},
	{                               /* Pattern drawing routines */
		PatternPixel,
		PatternLineHorizontal,
		PatternLineVertical,
		PatternBlock,
		PatternTrapezoidHorizontal,
		PatternTrapezoidVertical,
		PatternHairLine,
		PatternDrawMask,
		PatternChangeOrigin
	},

	CursorSet,
	CursorMove,
	CursorGet,

	PixelRead,
	PixelReadNextX,
	PixelReadPrevX,
	PixelReadNextY,
	PixelReadPrevY,
	PixelSet,
	PixelSetNextX,
	PixelSetPrevX,
	PixelSetNextY,
	PixelSetPrevY,

	CopyArea,	/* CopyArea */

	BufferSize, /* BufferSize */
	8,8,		/* size of FastPattern */
	BITMAP_DIRECTION_VERTICAL,

	nimp
	};
