/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10
	test for picture handling

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 21 December 1995
*/

#include "mem_h"
#include "job_h"
#include "io_h"

#include "PROforma_h"

#define catch(x) if (err=(x)) return err; else

Bbox bbox = { short2pt(595), short2pt(300), short2pt(0), short2pt(0) };

Error init()
{
	Gstate gstate;
	Error err;
	char *base;
	Channel file;
	Size size;

	LinkPROforma();
/*	  catch( PFGstateInit(PF_DRIVER_SCREEN,NULL,&bbox,&gstate,NULL) ); */
	catch( PFGstateInit(PF_NAME("Epson Stylus Colour 180dpi"),"pard",&bbox,&gstate,NULL) );
	
	catch( IOOpen("win1_tmp_car2_com",OPEN_OLD,&file) );
	catch( IOLength(file,&size) );
	catch( MEMAllocate(size,&base) );
	catch( IOLoadFile(file,size,base) );
	IOClose(file);

	PFMoveTo(gstate,short2pt(50),short2pt(50));
	catch( PFPictureDisplay(gstate,PF_PICTURE_PAINTER8,base, short2pt(495), short2pt(200)) );
	PFFontScale(gstate,short2pt(20));
	PFStringShow(gstate,"The picture is displayed here ");

	err=PFPageShow(gstate);

	{
		Time start, curr;

		/* wait for approx 15sec. */
		TIMEGet(&start);
		do {
			JOBSuspend(MYSELF,1,NULL);
			TIMEGet(&curr);
		} while (start+15>curr);
	}
	return err;
}
