/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10
	test to check that printing a string works

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 30 September 1995
*/

#include "sms_h"
#include "job_h"
#include "time_h"

#include "PROforma_h"

Bbox bbox={short2pt(200), short2pt(100),0,0};

Error init()
{
	Gstate gstate;
	Error err;

	LinkPROforma();
	err=PFGstateInit(PF_DRIVER_SCREEN,NULL,&bbox,&gstate,NULL);
	if (err) return err;
	err=PFPageShow(gstate);
	if (err) return err;

	err=PFFontLoad(gstate,"Akka");
	if (err) return err;
	PFFontScale(gstate,short2pt(40));

	PFMoveTo(gstate,short2pt(20),short2pt(60));
	PFStringShow(gstate,"\\alpha\\Hello World");

	err=PFPageShow(gstate);

	{
		Time start, curr;

		/* wait for approx 5sec. */
		TIMEGet(&start);
		do {
			JOBSuspend(MYSELF,1,NULL);
			TIMEGet(&curr);
		} while (start+5>curr);
	}
	return err;
}
